



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于OOM那些事儿</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于OOM那些事儿</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 00:44:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近在aliyun上crontab里放的一个java脚本把机器搞翻了，ssh连不上T_T 发现OOM了，真是无语。并不懂Java的内存模型，转一篇备用吧。</p>
<p>转载自：<a href="http://www.cnblogs.com/gaojing/archive/2012/10/30/2844938.html" rel="external nofollow noreferrer">http://www.cnblogs.com/gaojing/archive/2012/10/30/2844938.html</a></p>
<p>最近查找了很多关于OOM，甚至于Java内存管理以及JVM的相关资料，发现这方面的东西太多了，竟有一种眼花缭乱的感觉，要想了解全面的话，恐非一篇文章能说清的，因此按照自己的理解整理了一篇，剩下的还需要继续学习。</p>
<p>1）什么是OOM？ OOM，全称“Out Of Memory”，翻译成中文就是“内存用完了”，来源于java.lang.OutOfMemoryError。看下关于的官方说明： Thrown when the Java Virtual Machine cannot allocate an object because it is out of memory, and no more memory could be made available by the garbage collector. 意思就是说，当JVM因为没有足够的内存来为对象分配空间并且垃圾回收器也已经没有空间可回收时，就会抛出这个error（注：非exception，因为这个问题已经严重到不足以被应用处理）。</p>
<p>2）为什么会OOM？</p>
<p>为什么会没有内存了呢？原因不外乎有两点：</p>
<p>1）分配的少了：比如虚拟机本身可使用的内存（一般通过启动时的VM参数指定）太少。</p>
<p>2）应用用的太多，并且用完没释放，浪费了。此时就会造成内存泄露或者内存溢出。</p>
<p>内存泄露：申请使用完的内存没有释放，导致虚拟机不能再次使用该内存，此时这段内存就泄露了，因为申请者不用了，而又不能被虚拟机分配给别人用。<br />
内存溢出：申请的内存超出了JVM能提供的内存大小，此时称之为溢出。</p>
<p>在之前没有垃圾自动回收的日子里，比如C语言和C++语言，我们必须亲自负责内存的申请与释放操作，如果申请了内存，用完后又忘记了释放，比如C++中的new了但是没有delete，那么就可能造成内存泄露。偶尔的内存泄露可能不会造成问题，而大量的内存泄露可能会导致内存溢出。</p>
<p>而在Java语言中，由于存在了垃圾自动回收机制，所以，我们一般不用去主动释放不用的对象所占的内存，也就是理论上来说，是不会存在“内存泄露”的。但是，如果编码不当，比如，将某个对象的引用放到了全局的Map中，虽然方法结束了，但是由于垃圾回收器会根据对象的引用情况来回收内存，导致该对象不能被及时的回收。如果该种情况出现次数多了，就会导致内存溢出，比如系统中经常使用的缓存机制。Java中的内存泄露，不同于C++中的忘了delete，往往是逻辑上的原因泄露。</p>
<p>3）OOM的类型</p>
<p>JVM内存模型：</p>
<p>按照JVM规范，JAVA虚拟机在运行时会管理以下的内存区域：<br />
程序计数器：当前线程执行的字节码的行号指示器，线程私有<br />
JAVA虚拟机栈：Java方法执行的内存模型，每个Java方法的执行对应着一个栈帧的进栈和出栈的操作。<br />
本地方法栈：类似“ JAVA虚拟机栈 ”，但是为native方法的运行提供内存环境。<br />
JAVA堆：对象内存分配的地方，内存垃圾回收的主要区域，所有线程共享。可分为新生代，老生代。<br />
方法区：用于存储已经被JVM加载的类信息、常量、静态变量、即时编译器编译后的代码等数据。Hotspot中的“永久代”。<br />
运行时常量池：方法区的一部分，存储常量信息，如各种字面量、符号引用等。<br />
直接内存：并不是JVM运行时数据区的一部分， 可直接访问的内存， 比如NIO会用到这部分。<br />
按照JVM规范，除了程序计数器不会抛出OOM外，其他各个内存区域都可能会抛出OOM。</p>
<p>最常见的OOM情况有以下三种：<br />
java.lang.OutOfMemoryError: Java heap space ------&gt;java堆内存溢出，此种情况最常见，一般由于内存泄露或者堆的大小设置不当引起。对于内存泄露，需要通过内存监控软件查找程序中的泄露代码，而堆大小可以通过虚拟机参数-Xms,-Xmx等修改。<br />
java.lang.OutOfMemoryError: PermGen space ------&gt;java永久代溢出，即方法区溢出了，一般出现于大量Class或者jsp页面，或者采用cglib等反射机制的情况，因为上述情况会产生大量的Class信息存储于方法区。此种情况可以通过更改方法区的大小来解决，使用类似-XX:PermSize=64m -XX:MaxPermSize=256m的形式修改。另外，过多的常量尤其是字符串也会导致方法区溢出。<br />
java.lang.StackOverflowError ------&gt; 不会抛OOM error，但也是比较常见的Java内存溢出。JAVA虚拟机栈溢出，一般是由于程序中存在死循环或者深度递归调用造成的，栈大小设置太小也会出现此种溢出。可以通过虚拟机参数-Xss来设置栈的大小。<br />
4）OOM分析--heapdump</p>
<p>要dump堆的内存镜像，可以采用如下两种方式：<br />
设置JVM参数-XX:+HeapDumpOnOutOfMemoryError，设定当发生OOM时自动dump出堆信息。不过该方法需要JDK5以上版本。<br />
使用JDK自带的jmap命令。&quot;jmap -dump:format=b,file=heap.bin &quot; 其中pid可以通过jps获取。<br />
dump堆内存信息后，需要对dump出的文件进行分析，从而找到OOM的原因。常用的工具有：<br />
mat: eclipse memory analyzer, 基于eclipse RCP的内存分析工具。详细信息参见：<a href="http://www.eclipse.org/mat/，推荐使用" rel="external nofollow noreferrer">http://www.eclipse.org/mat/，推荐使用</a>。<br />
jhat：JDK自带的java heap analyze tool，可以将堆中的对象以html的形式显示出来，包括对象的数量，大小等等，并支持对象查询语言OQL，分析相关的应用后，可以通过http://localhost:7000来访问分析结果。不推荐使用，因为在实际的排查过程中，一般是先在生产环境 dump出文件来，然后拉到自己的开发机器上分析，所以，不如采用高级的分析工具比如前面的mat来的高效。<br />
这个链接：<a href="http://www.ibm.com/developerworks/cn/opensource/os-cn-ecl-ma/index.html中提供了一个采用mat分析的例子" rel="external nofollow noreferrer">http://www.ibm.com/developerworks/cn/opensource/os-cn-ecl-ma/index.html中提供了一个采用mat分析的例子</a> 。</p>
<p>注意：因为JVM规范没有对dump出的文件的格式进行定义，所以不同的虚拟机产生的dump文件并不是一样的。在分析时，需要针对不同的虚拟机的输出采用不同的分析工具（当然，有的工具可以兼容多个虚拟机的格式）。IBM HeapAnalyzer也是分析heap的一个常用的工具。</p>
<p>5）小结</p>
<p>涉及到的虚拟机的技术或者工具，往往需要考虑到虚拟机规范以及不同的虚拟机实现。尤其是针对虚拟机调优时，往往需要针对虚拟机在某些方面的实现策略来考虑，比如，不同的虚拟机的垃圾回收算法是不一样的，而这直接影响了虚拟机某些参数的设置，以达到虚拟机的最佳性能。<br />
而针对JVM运行时的分析与诊断，则需要掌握分析基本方法，针对具体情况，运用虚拟机的原理，具体分析。一句话，水很深啊。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4ynjqz.html">工欲善其事，必先利其器 之 VS2013全攻略&lpar;安装，技巧，快捷键，插件）！</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdengz9.html">highcharts去掉版权&vert;去掉水印链接&lpar;右下角&rpar;&lowbar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e55mk8.html">as3绕过策略文件给视频截图</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv0k5x8.html">Java-用switch判断季节</a>
		</li>
						<li><a href="https://www.batexi.com/a/495dryzq.html">&lbrack;DFNews&rsqb; Cellebrite UFED Logical&sol;Physical Analyzer 3&period;8&period;1 维护性更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdyd20q.html">&period;gitignore配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj26m49.html">js中的继承2--原型继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oke1559.html">QComboBox调用clear函数崩溃的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1voymq.html">tabbar颜色与文字大小&comma;状态栏样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpo7k79.html">python网络编程之网络主机信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp537jq.html">download下载excel模板的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxke24d8.html">Jsp&mdash;&mdash;http status 404 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1k13oq.html">简单RPC框架-业务线程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw33k9.html">SVN的目录管理规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eygrek9.html">第7章 UserInfo端点&lpar;UserInfo Endpoint&rpar; - IdentityModel 中文文档&lpar;v1&period;0&period;0&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ev5v8.html">Spark学习之路 （一）Spark初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxje38.html">&lbrack;Swift&rsqb;LeetCode722&period; 删除注释 &vert; Remove Comments</a>
		</li>
						<li><a href="https://www.batexi.com/a/95ggo36q.html">SPI 方式初始化 SD 卡总流程图（V2&period;0）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyz5j2q.html">Zabbix 课程大纲</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jld43q.html">USB-IF协会公布最新PD3&period;0（PPS）协议认证芯片和产品名单</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4ryj08.html">ehcache 一二事 - ssm 中ehcashe的简单配置应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2ojvx9.html">android ant 自动编译打包</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlg1j09.html">Adivisor</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zdkjv9.html">5050 &lbrack;JL&rsqb; 他爱上了鸭蛋</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq105x08.html">&lbrack;tools&rsqb;google神器浏览器下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p03jkq.html">ios 定位 监听是否跨入某个指定的区域</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g25yz8.html">&lbrack;CareerCup&rsqb; 7&period;7 The Number with Only Prime Factors 只有质数因子的数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlgvde9.html">地图坐标转换 -- 火星坐标与GPS坐标</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7620e8.html">&period;NET Core手记 - Json&period;NET的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jwv6w8.html">Win10&sol;UWP开发&mdash;使用Cortana语音指令启动前台App</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
